VERSION 2.00
Begin Form Form1 
   Caption         =   "VBSort"
   ClientHeight    =   4425
   ClientLeft      =   1095
   ClientTop       =   1485
   ClientWidth     =   7335
   Height          =   4830
   Left            =   1035
   LinkMode        =   1  'Source
   LinkTopic       =   "Form1"
   ScaleHeight     =   4425
   ScaleWidth      =   7335
   Top             =   1140
   Width           =   7455
   Begin CommandButton Command1 
      Caption         =   "About VBSort"
      Height          =   315
      Left            =   3000
      TabIndex        =   9
      Top             =   2700
      Width           =   1575
   End
   Begin CommandButton B_SortArray 
      Caption         =   "Sort Array"
      Height          =   495
      Left            =   3180
      TabIndex        =   6
      Top             =   1740
      Width           =   1215
   End
   Begin CommandButton B_SortList 
      Caption         =   "Sort List"
      Height          =   495
      Left            =   3180
      TabIndex        =   1
      Top             =   960
      Width           =   1215
   End
   Begin ListBox List3 
      Height          =   2760
      Left            =   5940
      TabIndex        =   8
      Top             =   540
      Width           =   855
   End
   Begin ListBox List2 
      FontBold        =   -1  'True
      FontItalic      =   0   'False
      FontName        =   "Courier"
      FontSize        =   9.75
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   2760
      Left            =   4860
      TabIndex        =   4
      Top             =   540
      Width           =   975
   End
   Begin ListBox List1 
      FontBold        =   -1  'True
      FontItalic      =   0   'False
      FontName        =   "Courier"
      FontSize        =   9.75
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   2760
      Left            =   540
      TabIndex        =   0
      Top             =   540
      Width           =   2235
   End
   Begin Label Label4 
      Height          =   795
      Left            =   4620
      TabIndex        =   7
      Top             =   3420
      Width           =   2835
   End
   Begin Label Label1 
      Height          =   375
      Left            =   420
      TabIndex        =   2
      Top             =   3420
      Width           =   2775
   End
   Begin Label Label3 
      Caption         =   "Array:"
      Height          =   195
      Left            =   4800
      TabIndex        =   5
      Top             =   240
      Width           =   615
   End
   Begin Label Label2 
      Caption         =   "List:"
      Height          =   255
      Left            =   540
      TabIndex        =   3
      Top             =   240
      Width           =   555
   End
End
Dim Topp(10), Bottom(10), array$(2, 26), LastArray

Sub B_SortArray_Click ()
  Call SortArray(array$())
  For i = 0 To LastArray
    List2.List(i) = array$(1, i)
    List3.List(i) = array$(2, i)
  Next
  Label4.caption = "Note that the second element of the array is sorted along with the first."
End Sub

Sub B_SortList_Click ()
  Call SortList(List1)
  Label1.caption = "Note that the lines are sorted alphabetically, not numerically."
End Sub

Sub Command1_Click ()
  Msg$ = "This sample program contains two routines: " + Chr$(10) + Chr$(13)
  Msg$ = Msg$ + "One to sort a List box and one to sort an array. " + Chr$(10) + Chr$(13) + Chr$(10) + Chr$(13)
  Msg$ = Msg$ + "The routines are under General Proc.'s " + Chr$(10) + Chr$(13) + Chr$(10) + Chr$(13)
  Msg$ = Msg$ + "This sample file is Copyright 1991 Nelson Ford, PsL."
  Msg$ = Msg$ + "You may modify and use the routines. You may also distribute this file to others, as long you do not change the contents." + Chr$(10) + Chr$(13) + Chr$(10) + Chr$(13)
  Msg$ = Msg$ + "For more routines for VB, see DLs 1 and 6 on MSLANG on CIS, "
  Msg$ = Msg$ + "or call Public (software) Library for a free newsletter. "
  Msg$ = Msg$ + "800-242-4775 or on CIS: 71355,470."
  MsgBox Msg$

End Sub

Sub Form_Load ()
  For i = 26 To 1 Step -1
    List1.AddItem Str$(i)
  Next
  j = 0
  For i = 90 To 65 Step -1
    List2.AddItem Chr$(i)
    List3.AddItem Str$(i)
    array$(1, j) = Chr$(i)
    array$(2, j) = Str$(i)
    j = j + 1
  Next
  LastArray = 25
End Sub

Sub SortArray (array$())
  MousePointer = 11
  Ply = 1
  Bottom(1) = 0
  Topp(1) = LastArray
 
  While Ply > 0
    If Bottom(Ply) >= Topp(Ply) Then
      Ply = Ply - 1
    Else
      i = Bottom(Ply) - 1
      j = Topp(Ply)
      Pt$ = array$(1, j)
      While i < j
        i = i + 1
        j = j - 1
        While array$(1, i) < Pt$: i = i + 1: Wend
        While array$(1, j) > Pt$ And j > i: j = j - 1: Wend
        If i < j Then
          x$ = array$(1, i)
          array$(1, i) = array$(1, j)
          array$(1, j) = x$
          x$ = array$(2, i)
          array$(2, i) = array$(2, j)
          array$(2, j) = x$
        End If
      Wend
      j = Topp(Ply)
      If i <> j And array$(1, i) > array$(1, j) Then
        x$ = array$(1, i)
        array$(1, i) = array$(1, j)
        array$(1, j) = x$
        x$ = array$(2, i)
        array$(2, i) = array$(2, j)
        array$(2, j) = x$
      End If
      If i - Bottom(Ply) < Topp(Ply) - i Then
        Bottom(Ply + 1) = Bottom(Ply)
        Topp(Ply + 1) = i - 1
        Bottom(Ply) = i + 1
      Else
        Topp(Ply + 1) = Topp(Ply)
        Bottom(Ply + 1) = i + 1
        Topp(Ply) = i - 1
      End If
      Ply = Ply + 1
    End If
  Wend
  MousePointer = 0

End Sub

Sub SortList (slist1 As Control)
  MousePointer = 11
  Ply = 1
  Bottom(1) = 0
  Topp(1) = slist1.listcount - 1
  While Ply > 0
    If Bottom(Ply) >= Topp(Ply) Then
      Ply = Ply - 1
    Else
      i = Bottom(Ply) - 1
      j = Topp(Ply)
      Pt$ = slist1.List(j)
      While i < j
        i = i + 1
        j = j - 1
        While slist1.List(i) < Pt$: i = i + 1: Wend
        While slist1.List(j) > Pt$ And j > i: j = j - 1: Wend
        If i < j Then
          x$ = slist1.List(i)
          slist1.List(i) = slist1.List(j)
          slist1.List(j) = x$
        End If
      Wend
      j = Topp(Ply)
      If i <> j And slist1.List(i) > slist1.List(j) Then
        x$ = slist1.List(i)
        slist1.List(i) = slist1.List(j)
        slist1.List(j) = x$
      End If
      If i - Bottom(Ply) < Topp(Ply) - i Then
        Bottom(Ply + 1) = Bottom(Ply)
        Topp(Ply + 1) = i - 1
        Bottom(Ply) = i + 1
      Else
        Topp(Ply + 1) = Topp(Ply)
        Bottom(Ply + 1) = i + 1
        Topp(Ply) = i - 1
      End If
      Ply = Ply + 1
    End If
  Wend
  MousePointer = 0

End Sub

